/*!
 * jQswipe v@VERSION - Swipe event for jQuery.
 * http://github.com/dinoboff/jQswipe/
 *
 * Copyright (c) 2009 Damien Lebrun
 * licenced under BSD
 * http://github.com/dinoboff/jQswipe/blob/master/LICENSE
 * 
 * Date: @DATE
 */
(function(){var b=this,d=b.jQuery,a=d.jQswipe={},c;d.each(["touches","targetTouches"],function(e,f){if(d.inArray(f,d.event.props)<0){d.event.props.push(f)}});a.Swipe=function(e){d.extend(this,e)};c=a.Swipe.STATE={RUNNING:1,ENDED:2,CANCELLED:-1};a.Swipe.prototype={touches:[],type:"swipe",state:null,minLength:30,maxWidth:10,keepLast:2,reset:function(e){this.touches=[];this.state=c.RUNNING},push:function(e){var f;if(e.length===1){f=e[0]}if(f&&f.pageX!==undefined&&f.pageY!==undefined){this.touches.push({pageX:f.pageX,pageY:f.pageY});this.compress();return this.size()-1}this.cancel();return -1},size:function(e){return this.touches.length},compress:function(){var f=this.size(),e;if(!this.keepLast||this.keepLast<1){return}e=f-this.keepLast-1;if(e>0){this.touches.splice(1,e)}},atIndex:function(e){var f=this.touches.length;if(f<1){return}e=((Math.floor(Math.abs(e/f))+1)*f+e)%f;return this.touches[e]},diff:function(h,g){var f=this.atIndex(h),e=this.atIndex(g);return{x:e.pageX-f.pageX,y:e.pageY-f.pageY}},validate:function(){var f=this.diff(0,-1),e=this.diff(-2,-1);if(this.state===c.CANCELLED){return false}if(f.y>this.maxWidth||f.y<-this.maxWidth||e.x<0){this.cancel();return false}if(this.state===c.ENDED&&f.x<this.minLength){return false}return true},cancel:function(){this.state=c.CANCELLED},end:function(){this.state=c.ENDED}};a.SwipeSpecialEvent=function(e,f){var g=this;this.settings=f||{};this.settings.type=e||"swipe";this.setup=function(l,k){var i=d(this),j=g.prepareNamespaces(k),h=new d.jQswipe.Swipe(g.settings);d.each(["touchstart","touchmove","touchcancel","touchend"],function(m,n){j[0]=n;i.bind(j.join("."),h,g[n]);delete g[n].guid})};this.teardown=function(j){var h=d(this),i=g.prepareNamespaces(j);d.each(["touchstart","touchmove","touchcancel","touchend"],function(k,l){i[0]=l;h.unbind(i.join("."))})}};a.SwipeSpecialEvent.prototype={prepareNamespaces:function(e){var f=e.slice(0,e.length);f.splice(0,0,"",this.settings.type);return f},touchstart:function(f){var e=f.data;e.reset();e.push(f.targetTouches||[])},touchmove:function(f){var e=f.data;if(e.validate()){e.push(f.targetTouches||[])}},touchcancel:function(f){var e=f.data;e.cancel()},touchend:function(f){var e=f.data;e.end();if(e.validate()){f.type=e.type;d.event.handle.apply(this,arguments)}}};a.register=function(f,e){d.event.special[f]=new d.jQswipe.SwipeSpecialEvent(f,e)};a.register("swipe");a.register("rightSwipe");a.register("leftSwipe",{validate:function(){var f=this.diff(0,-1),e=this.diff(-2,-1);if(this.state===c.CANCELLED){return false}if(f.y>this.maxWidth||f.y<-this.maxWidth||e.x>0){this.cancel();return false}if(this.state===c.ENDED&&f.x>-(this.minLength)){return false}return true}});d.fn.swipe=function(e){return d(this).bind("swipe",e)}})();