        var wsuri = "ws://localhost:8080";

		var logging = false;

		
         function onEvent(topic, event) {
            if(logging) console.log("onEvent topic:"+topic);
            if(logging) console.log("onEvent event:"+event);
         }

         function publishEvent(msg)
         {
            sess.publish("MarkerEvent", msg,true);
         }

         function callProcedure() {
            // issue an RPC, returns promise object
            sess.call("FeederDevice", 23, 7).then(

               // RPC success callback
               function (res) {
                  if(logging) console.log("got result: " + res);
               },

               // RPC error callback
               function (error) {
                  if(logging) console.log("error: " + error.desc);
               }
            );
         }
         function callFeederMarker() {
            // issue an RPC, returns promise object
            sess.call("marker", {device:"MRI_EMU1",item:"marker1",cmd:"MARKER",parms:{num:1,t:123,x:0.5,y:0.1,z:0.0,ya:90.0,pa:0.0,ra:0.0,v:1}}).then(

               // RPC success callback
               function (res) {
                  if(logging) console.log("got result: " + res);
               },

               // RPC error callback
               function (error) {
                  if(logging) console.log("error: " + error.desc);
               }
            );
         }
         
         function callError() {
             // issue an RPC, returns promise object
             sess.call("CallException", 23, 7).then(

                // RPC success callback
                function (res) {
                   if(logging) console.log("got result: " + res);
                },

                // RPC error callback
                function (error) {
                   if(logging) console.log("error: " + error.desc);
                }
             );
          }